<?php

namespace Drush\Commands\dev_modules;

use Drush\Commands\DrushCommands;

/**
 * Global Drush command to enable/disable all development modules at once.
 */
class DevModulesCommands extends DrushCommands {

  /**
   * DevModulesCommands constructor.
   */
  public function __construct() {
    require_once __DIR__ . '/DevModulesInterface.php';
    require_once __DIR__ . '/DevModules.php';
    require_once __DIR__ . '/DevModules8.php';
  }

  /**
   * Enable/disable all development modules at once.
   *
   * @command site:dev
   * @aliases dev-modules, dev
   * @bootstrap full
   * @param $flag On or off, yes or no, True or False, 1 or 0.
   * @option list Only determine the list of modules and print that list to the console
   *
   * @throws \Exception
   */
  public function devMode($flag, $options = ['list' => FALSE]) {
    $devModules = new DevModules8();
    $list = $devModules
      ->setEnableMode($flag)
      ->prepareModules()
      ->processModules($options['list']);
    if ($options['list']) {
      $this->io()->section('Enable');
      $this->io()->listing($list['enable']);
      $this->io()->section('Disable');
      $this->io()->listing($list['disable']);
    }
  }

}
